/**
* @NApiVersion 2.1
* @NScriptType Restlet
* @NModuleScope Public
*/

var 
	log,
	query,
	response = {};


define( [ 'N/log', 'N/query' ], main );


function main( logModule, queryModule ) {

	log = logModule;
	query = queryModule;

    return { post: postProcess }

}


function postProcess( request ) {	
	
	try {
	
		if ( ( typeof request.query == 'undefined' ) || ( request.query === null ) || ( request.query === '' ) ) {
			throw { 'type': 'error.SuiteAPIError', 'name': 'INVALID_REQUEST', 'message': 'No query was specified.' }
		}	
	
		if ( typeof request.params == 'undefined' ) { request.params = []; }
		if ( typeof request.pageSize == 'undefined' ) { request.pageSize = 1000 }
					
		const resultIterator = query.runSuiteQLPaged({
			query: request.query,
			params: request.params,
			pageSize: request.pageSize
		}).iterator();

		const results = [];
		resultIterator.each(function(page) {
			const pageIterator = page.value.data.iterator();
			pageIterator.each(function(row) {
				results.push(row.value.values);
				return true;
			});
			return true;
		});
		response.items = results;
							
		return response;
				
	} catch( e ) {	
		log.debug( { 'title': 'error', 'details': e } );
		return { 'error': { 'type': e.type, 'name': e.name, 'message': e.message } }
	}	
		
}
